
System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = init;

reset();

var currentWoWServer;
var refreshTimer;
var refreshTime;
var fadeTimer;


var typeDescriptions =['Type: ', 'Type: ', 'Art: ', 'Type: ', ''];
var populationDescriptions =['Population: ', 'Population: ', 'Bevlkerung: ', 'Population: ', ''];


function init()
{
	wowstatusBg.src = "url(resources/background.png)";
	System.Gadget.Flyout.file = "flyout.html";
    var mySetting = new SlaineWoWRealmSettings();
    if(mySetting!=null)
    {
	    mySetting.load();     
        refreshTime = new Number(mySetting.RefreshServer) * 60000;
    	CallRealmStatus(new WoWServer(mySetting.Region, mySetting.Realm));
	    System.Gadget.visibilityChanged = checkVisibility;
    }
}

function addContentToFlyout()
{
    try
    {
        if(System.Gadget.Flyout.show)
        {
            var realmName = 'Default';
            var realmType = 'Default';
            var realmPopulation = 'Default';                        
            try
            {
            	if (currentWoWServer!=null)
			    {
			        if(currentWoWServer.server.length>20)
			        {
			            var trunc = currentWoWServer.server.substring(0, 17);
			            trunc += ' ...';
			            realmName = trunc ;
			            
			        } else {
			            realmName = currentWoWServer.server;
			        }
			       
			        switch (currentWoWServer.region)
				    {
					    case 'Europe-En':
					    
					        if (currentWoWServer.type == 'NF')
					        {
					            realmType  =  'Realm not found';     
			                    realmPopulation  = '';
					        }
					        else
					        {	  
						        realmType  =  typeDescriptions[0] + currentWoWServer.type;   
			                    realmPopulation  = populationDescriptions[0] + currentWoWServer.population;
			                }
					   	    break;
					   	case 'Europe-Fr':
					        if (currentWoWServer.type == 'NF')
					        {
					            realmType  =  'Realm not found';     
			                    realmPopulation  = '';
					        }
					        else
					        {	  
						        realmType  =  typeDescriptions[1] + currentWoWServer.type;   
			                    realmPopulation  = populationDescriptions[1] + currentWoWServer.population;
			                }
					   	    break;
					   	case 'Europe-De':
			 		        if (currentWoWServer.type == 'NF')
					        {
					            realmType  =  'Realm not found';     
			                    realmPopulation  = '';
					        }
					        else
					        {	  
						        realmType = typeDescriptions[2] + currentWoWServer.type;   
			                    realmPopulation  = populationDescriptions[2] + currentWoWServer.population;
			                }
			 
					   	    break;
					    case 'USA':
					        if (currentWoWServer.type == 'NF')
					        {
					            realmType  =  'Realm not found';     
			                    realmPopulation  = '';
					        }
					        else
					        {	  
						        realmType  =  typeDescriptions[3] + currentWoWServer.type;   
			                    realmPopulation  = populationDescriptions[3] + currentWoWServer.population;
			                }
			                break;
					    case 'KR':
					        if (currentWoWServer.type == 'NF')
					        {
					            realmType   =  'Realm not found';     
			                    realmPopulation   = '';
					        }
					        else
					        {	  
						        realmType    =  typeDescriptions[4] + currentWoWServer.type;   
			                    realmPopulation    = populationDescriptions[4] + currentWoWServer.population;
			                }
			               
			               break;
					    default:
						    break;
				    }
    			} else {
			        realmName  = 'Select a Realm';
			        realmType =  '';   
			        realmPopulation  = '';
   				 }
            
            	var flyoutDiv =  System.Gadget.Flyout.document;
                flyoutDiv.getElementById("RealmName").innerHTML = realmName;
                flyoutDiv.getElementById("RealmType").innerHTML = realmType;
                flyoutDiv.getElementById("RealmPopulation").innerHTML = realmPopulation;
            }
            catch(e)
            {
            
            	flyoutDiv.getElementById("RealmName").innerHTML = "Error";
            
            }
            
        }
    }
    catch(e)
    {
        flyoutDiv.title = "Error";
    }
}



function checkVisibility()
{
    isVisible = System.Gadget.visible;
    if (!isVisible)
    {
 		if (refreshTimer!=null)
        {
            window.clearTimeout(refreshTimer);
            refreshTimer = null;

        }
    }
}

function openWoW()
{

/*
    var mySetting = new SlaineWoWRealmSettings();
    if(mySetting!=null)
    {
    	var fso = new ActiveXObject("Scripting.FileSystemObject")
    	if(fso.FileExists(fso.BuildPath(mySetting.WoWPath,"wow.exe")))
    	{
    		var shell = new ActiveXObject("WScript.shell");
			shell.Run(url);
			shell = null;
		}
		fso  = null;
    }
 */
}

function launchRealmStatus()
{

	var serverStatusURLs = ['http://www.wow-europe.com/en/serverstatus/', 'http://www.wow-europe.com/fr/serverstatus/', 'http://www.wow-europe.com/de/serverstatus/', 'http://www.worldofwarcraft.com/realmstatus/', 'http://www.worldofwarcraft.co.kr/serverstatus/'];
	var url;
	switch (currentWoWServer.region)
	{
		case 'Europe-En':	  
			url = serverStatusURLs[0];
			break;
		case 'Europe-Fr':	  
			url = serverStatusURLs[1];
			break;
		case 'Europe-De':	  
			url = serverStatusURLs[2];
			break;
		case 'USA':	  
			url = serverStatusURLs[3];
			break;
		case 'KR':	  
			url = serverStatusURLs[4];
			break;
		default:
			break;
	}
	
	//This opens ie (or the default browser) and opens the status page.
	var shell = new ActiveXObject("WScript.shell");
	shell.Run(url);
	shell = null;
	toggleGlobe();
}


function toggleGlobe()
{
    

    if (StatusLink.style.backgroundImage=='url(none)')
        StatusLink.style.backgroundImage='url(resources/globe.png)';
    else
        StatusLink.style.backgroundImage='url(none)';
}


function WoWServer(r, s)
{
    this.region = r;
    this.server = s;
    this.type = '';
    this.population = '';
    this.status = '';
}


function reset()
{

   if (currentWoWServer!=null)
   {
    currentWoWServer.type = '';
    currentWoWServer.population = '';
    currentWoWServer.status = '';
   }
    
   setBackground();       

}

function CallRealmStatus(wowServer)
{

    //alert('Loading... will refresh in ' + refreshTime + ' millisecs');
    var serverStatusDataURLS = ['http://www.wow-europe.com/en/serverstatus/', 'http://www.wow-europe.com/fr/serverstatus/', 'http://www.wow-europe.com/de/serverstatus/', 'http://www.worldofwarcraft.com/realmstatus/status.xml', 'http://www.worldofwarcraft.co.kr/serverstatus/'];
   
    currentWoWServer = wowServer
    reset();
    //alert('Refresh');

    if (window.XMLHttpRequest) {
		req = new XMLHttpRequest();
	} else if (window.ActiveXObject) {
		req = new ActiveXObject("Microsoft.XMLHTTP");
	}

	switch (currentWoWServer.region)
	{
		case 'Europe-En':	  
			req.open("GET", serverStatusDataURLS[0], true);
			break;
	    case 'Europe-Fr':	  
			req.open("GET", serverStatusDataURLS[1], true);
			break;
	    case 'Europe-De':	  
			req.open("GET", serverStatusDataURLS[2], true);
			break;
		case 'USA':	  
			req.open("GET", serverStatusDataURLS[3], true);
			break;
		case 'KR':	  
			req.open("GET", serverStatusDataURLS[4], true);
			
			break;
		default:
			break;
	}
	req.onreadystatechange = readServerStatus;

	req.send(null);
}

function readServerStatus()
{ 
    if(req.readyState==4){
        if(req.status==200){
            var serverString = currentWoWServer.server.replace(/\'/g, '&#039;');
            var expr = '';
            switch (currentWoWServer.region)
	        {
		        case 'Europe-En':
		        case 'Europe-Fr':
		        case 'Europe-De':
		            expr = '(up|down)arrow.gif\\"[^>]+><\\/td>\\s*<td [^>]+><b [^>]+>' + serverString + '<\\/b><\\/span><\\/td>\\s*<td [^>]+><small [^>]+>(.*)<\\/small><\\/td>\\s*<td [^>]+>(?:<span><b><font [^>]+>(.*)<\\/(?:font|style)><\\/b><\\/span>|)<\\/td>\\s*';
		            break;
		        case 'USA':
		            expr = '<r n=\"' + serverString  + '" t=\"([0-9])\" s=\"([0-9])\" l=\"([0-9])\"/>';
		            break;
		        case 'KR':
		            expr = '(up|down).gif\"><\\/td>\\s+\\t+<td [^>]+><font [^>]+>\\s+\\t+' + serverString + '\\s+\\t+\\s+\\t+<\\/font><\\/td>\\s+\\t+\\s+\\t+<td [^>]+><font [^>]+>(.*)<\\/font><\\/td>\\s+\\t+\\s+\\t+\\s+\\t+\\s+\\t+\\s+\\t+\\s+\\t+<td [^>]+><font [^>]+>(.*)<\\/font><\\/td>';
		        default:
			        break;
	        }
            
            regex = new RegExp(expr, 'i');
	        backRef = regex.exec(req.responseText);
		    if (backRef!=null)
	        {
	            var _status = '';
	            switch (currentWoWServer.region)
	            {
		            case 'Europe-En':
		            case 'Europe-Fr':
		            case 'Europe-De':
		            case 'KR':
    	                switch (backRef[1])
		                {
			                case 'up':
				            case "down":
				                currentWoWServer.status = backRef[1];
				                break;
			                default:
				                currentWoWServer.status = '';
			                break;
		                }
		                currentWoWServer.type = backRef[2];
		                if (backRef[3]!='&nbsp;' & backRef[3]!='')
		                    currentWoWServer.population = backRef[3];
		                else
		                	currentWoWServer.population = 'Medium';
		                break;
		            case 'USA':
		                switch (backRef[2])
						{
							case '1':
								currentWoWServer.status = 'up';
								break;
							case "2":
								currentWoWServer.status = 'down';
								break;
							default:
								currentWoWServer.status = '';
								break;
						}
					
						switch (backRef[1])
						{
							case '1':
								currentWoWServer.type = 'Normal';
								break;
							case "2":
								currentWoWServer.type = 'PVP';
								break;
							case "3":
								currentWoWServer.type = 'RP';
								break;
							case "4":
								currentWoWServer.type = 'RPPVP';
								break;
						}              

						switch (backRef[3])
						{
							case '1':
								currentWoWServer.population = 'Low';
								break;
							case "2":
								currentWoWServer.population = 'Medium';
								break;
							case "3":
								currentWoWServer.population = 'High';
    							break;
							case "4":
								currentWoWServer.population = 'Max (Queued)';
    							break;
						}   
						break;
		         }
			        
	        } 
	        else 
	        {
		       currentWoWServer.type = 'NF';
		       
	        }
		    
	        setBackground();
	        if (refreshTimer!=null)
	        {
	            window.clearTimeout(refreshTimer);
	            refreshTimer = null;

	        }
                
	        refreshTimer = window.setTimeout("CallRealmStatus(currentWoWServer);", refreshTime);
	    }
	}
}


function setBackground()
{
	if (currentWoWServer!=null)
    {
        switch (currentWoWServer.region)
	    {
		    case 'Europe-En':
                wowstatusBg.src = 'url(resources/background_' + currentWoWServer.status + '_uk.png)' ;
		   	    break;
		   	case 'Europe-Fr':
				wowstatusBg.src = 'url(resources/background_' + currentWoWServer.status + '_fr.png)' ;
		   	    break;
		   	case 'Europe-De':
                wowstatusBg.src = 'url(resources/background_' + currentWoWServer.status + '_de.png)' ;
		   	    break;
		    case 'USA':
                wowstatusBg.src = 'url(resources/background_' + currentWoWServer.status + '_usa.png)' ;
		   	    break;
		    case 'KR':
                wowstatusBg.src = 'url(resources/background_' + currentWoWServer.status + '_kr.png)' ;
		   	    break;
		    default:
			    break;
	    }
	    RealmTitle.title = 'Last updated: ' + new Date().toLocaleString();
    } 
    else 
    {
    	try
	    {
	        RealmTitle.title = '';
	        wowstatusBg.src = 'url(resources/background.png)' ;
	    }
	    catch (e)
	    {
	    }
	    
    }
}

function toggleflyout()
{
	if (!System.Gadget.Flyout.show)
	{
		System.Gadget.Flyout.show = true;
		System.Gadget.Flyout.onShow = function()
        {
                addContentToFlyout();
        }
	}
	else
	{
		System.Gadget.Flyout.show = false;
	}
}