
function SlaineWoWRealmSettings()
{   
    //set event handlers
    this.save = saveSettingToDisk;
    this.load = loadSettingFromDisk;
    
    //Set default values
    this.Realm = "Thunderhorn" ; 
    this.Region = "Europe-En" ; 
    this.RefreshServer = 15 ; 
    this.WoWPath = "c:\program files\World of Warcraft\wow.exe";
    
}

////////////////////////////////////////////////////////////////////////////////
//
// load the information from disk
//
////////////////////////////////////////////////////////////////////////////////
function loadSettingFromDisk()
{
    if (System.Gadget.Settings.read("SettingsExist"))
    {
        this.Realm = System.Gadget.Settings.readString("Realm");
        this.Region= System.Gadget.Settings.read("Region");
        this.RefreshServer= System.Gadget.Settings.read("RefreshServer");
    }
}

////////////////////////////////////////////////////////////////////////////////
//
// save information to disk
//
////////////////////////////////////////////////////////////////////////////////
function saveSettingToDisk()
{
    System.Gadget.Settings.write("SettingsExist", true ); 
    System.Gadget.Settings.write("Realm", this.Realm );
    System.Gadget.Settings.write("Region", this.Region);
    System.Gadget.Settings.write("RefreshServer", this.RefreshServer);
}

function Trace (  str ) 
{ 
// Should we use System.Debug.outputString ?? 
    Debug.write ( str ) ; 
} 

