var mySetting = new SlaineWoWRealmSettings();

function loadSettings ( ) 
{ 
    mySetting.load();     
    System.Gadget.onSettingsClosing = settingsuiClosing;
    loadUI() ;    
} 

function saveSettings ( ) 
{ 
    saveUI(); 
    mySetting.save();
} 


function saveUI()
{
   mySetting.Realm = RealmUI.value ; 
   mySetting.Region = RegionUI.value ; 
   mySetting.RefreshServer = RefreshUI.value;
   //mySetting.WoWPath = WoWPathUI.value; 
}

function loadUI () 
{ 
   RealmUI.value = mySetting.Realm ; 
   RegionUI.value = mySetting.Region ; 
   RefreshUI.value  = mySetting.RefreshServer; 
   //WoWPathUI.value = mySetting.WoWPath;
} 

function settingsuiClosing(closeEvent)
{
    //Clear any error message
    var errormessage = '';
    var validate  = 0 ;
    Errors.innerHTML = 'Validating';
    
    if (closeEvent.closeAction == closeEvent.Action.commit)
    {
        // validate data here... if deciding not to save (invalid data, then set cancel to true ) 
	if(RealmUI.value.length ==0)
	{
           validate = validate + 1;
           errormessage = errormessage + "<li>You must enter a Realm.</li>";
        }
        
	if(RefreshUI.value.length ==0)
        {
           validate = validate + 1;
           errormessage = errormessage + "<li>You must enter a Refresh Rate.</li>";
	}
        else
        {
		if (isNaN(RefreshUI.value))
		{
			validate++;
			errormessage = errormessage + "<li>Server Refresh is not a number.</li>";
		}
	}

        if ( validate > 0 ) 
        { 
            Errors.innerHTML = "<ul>" + errormessage + "</ul>";
            closeEvent.cancel = true; 
        } else {      
            saveSettings();
            closeEvent.cancel = false; 
        }
    }
}